#!/usr/bin/python
# -*- coding: utf-8 -*-

# Name           : MWLegende
# Description    : (c) Michael Wilhelm
# Date           : 25.08.2018
# Copyright      : (c) Michael Wilhelm
# Email          : mwilhelm@hs-harz.de
# Web            : http://www.miwilhelm.de

# Import the PyQt and QGIS libraries
from qgis.PyQt.QtCore import *  # QSettings, QTranslator, QCoreApplication
from qgis.PyQt.QtGui import *  # QIcon, QCursor
from qgis.PyQt.QtWidgets import *  # QAction

from qgis.gui import *

from qgis.core import * # QgsProject, QgsMapLayer, QgsWkbTypes, QgsMapLayerRegistry, QgsCoordinateTransform, QgsPoint, QgsRaster, QgsLayerTreeLayer, QgsLayerTreeGroup

# Initialize Qt resources from file resources.py
from .resources import *		# new  
from .basis import * 	# new
from .vectorlayer import * 	# new
#import .basis
#import .vectorlayer

from  .uiselectcolor  import  uiSelectColor


class LegendColor:

	def __init__(self, iface):
		# Save reference to the QGIS interface
		self.iface = iface
		self.canvas = self.iface.mapCanvas()
		self.view = iface.layerTreeView()

	def run(self):
		# QMessageBox.information(self.iface.mainWindow(),"Hinweis", "LegendColor(extern)")
		dialog = uiSelectColor()
		result = dialog.exec_()
		if result:	
			pass
		else:
			return

		mainTree = self.iface.layerTreeView()
		currentgroup = mainTree.currentGroupNode()

		layer = getActiveShapeLayer(self.iface)
		if currentgroup==None and layer==None:
			QMessageBox.information(self.iface.mainWindow(),"Hinweis", "Es gab kein aktives Shape oder aktive Gruppe")
			return
		if layer==None:
			# currentgroup
			layers = getLayersFromExistingGroup(self.iface,currentgroup)
			if layers!=None:
				for layer in layers:
					sym = layer.renderer().symbol()
					color = QColor(dialog.r, dialog.g, dialog.b)
					sym.setColor(color)
					sym.setOpacity(1)
					#self.iface.legendInterface().refreshLayerSymbology(layer) 
					self.iface.layerTreeView().refreshLayerSymbology(layer.id())
				for layer in layers:
					layer.triggerRepaint()  	# repaintRequested
		else:
			# layer
			sym = layer.renderer().symbol()
			color = QColor(dialog.r, dialog.g, dialog.b)
			sym.setColor(color)
			sym.setOpacity(1)
			#self.iface.legendInterface().refreshLayerSymbology(layer) 
			self.iface.layerTreeView().refreshLayerSymbology(layer.id())
			layer.triggerRepaint()  	# repaintRequested