#!/usr/bin/python
# -*- coding: utf-8 -*-

# Name           : MWLegende
# Description    : (c) Michael Wilhelm
# Date           : 25.08.2018
# Copyright      : (c) Michael Wilhelm
# Email          : mwilhelm@hs-harz.de
# Web            : http://www.miwilhelm.de



# Import the PyQt and QGIS libraries
from qgis.PyQt.QtCore import *  # QSettings, QTranslator, QCoreApplication
from qgis.PyQt.QtGui import *  # QIcon, QCursor
from qgis.PyQt.QtWidgets import *  # QAction

from qgis.gui import *

from qgis.core import * # QgsProject, QgsMapLayer, QgsWkbTypes, QgsMapLayerRegistry, QgsCoordinateTransform, QgsPoint, QgsRaster, QgsLayerTreeLayer, QgsLayerTreeGroup

# Initialize Qt resources from file resources.py
from .resources import *		# new  

# registry
import sys
#from _winreg import *



class Farbe():
	def __init__(self, r,g,b):
		self.r=r
		self.g=g
		self.b=b;

# return the layer of the group with the name 'groupname'
def createPaletteNiederschlag(n):
	palette=[]
	if n<=2:
		palette.append( Farbe(205,133,63)) 
		palette.append( Farbe(31,71,145))  
	elif n==3:
		palette.append( Farbe(205,133,63)) 
		palette.append( Farbe(0,205,102)) 
		palette.append( Farbe(31,71,145))  
	elif n==4:
		palette.append( Farbe(205,133,63)) 
		palette.append( Farbe(186,237,0))  
		palette.append( Farbe(0,205,102)) 
		palette.append( Farbe(31,71,145))  
	elif n==5:
		palette.append( Farbe(205,133,63)) 
		palette.append( Farbe(255,255,000)) 
		palette.append( Farbe(186,237,0))  
		palette.append( Farbe(0,205,102)) 
		palette.append( Farbe(31,71,145))  
	elif n==6:
		palette.append( Farbe(205,133,63)) 
		palette.append( Farbe(255,215,0))  
		palette.append( Farbe(111,254,38))  
		palette.append( Farbe(2,220,0))  
		palette.append( Farbe(0,134,139))  
		palette.append( Farbe(31,71,145))  
	elif n==7:
		palette.append( Farbe(205,133,63)) 
		palette.append( Farbe(255,215,0))  
		palette.append( Farbe(186,237,0))  
		palette.append( Farbe(0,205,102))  
		palette.append( Farbe(2,186,0)) 
		palette.append( Farbe(0,134,139))  
		palette.append( Farbe(31,71,145))  
	elif n==8:
		palette.append( Farbe(205,133,63)) 
		palette.append( Farbe(255,165,0))  
		palette.append( Farbe(255,215,0))  
		
		palette.append( Farbe(186,237,0))  
		palette.append( Farbe(0,205,102))  
		palette.append( Farbe(2,186,0)) 
		palette.append( Farbe(0,134,139))  
		palette.append( Farbe(31,71,145))  
	elif n==9:
		palette.append( Farbe(205,133,63)) 
		palette.append( Farbe(255,165,0))  
		palette.append( Farbe(255,215,0))  
		palette.append( Farbe(186,237,0))  
		palette.append( Farbe(0,205,102))  
		palette.append( Farbe(2,186,0))  
		palette.append( Farbe(0,134,139))  
		palette.append( Farbe(43,101,129))  
		palette.append( Farbe(31,71,145))  
	elif n==10:
		palette.append( Farbe(205,133,63)) 
		palette.append( Farbe(255,165,0))  
		palette.append( Farbe(255,215,0))  
		
		palette.append( Farbe(186,237,0))  
		palette.append( Farbe(0,205,102))  
		palette.append( Farbe(2,220,0)) 		
		palette.append( Farbe(2,186,0)) 
		
		palette.append( Farbe(0,134,139))  
		palette.append( Farbe(43,101,129))  
		palette.append( Farbe(31,71,145))  

	elif n==11:
		palette.append( Farbe(205,133,63)) 
		palette.append( Farbe(255,165,0))  
		palette.append( Farbe(255,215,0))  

		palette.append( Farbe(186,237,0)) 
		palette.append( Farbe(111,254,38))  
		palette.append( Farbe(0,205,102))  
		palette.append( Farbe(2,220,0))  
		palette.append( Farbe(2,186,0))  
		
		palette.append( Farbe(0,134,139))  
		palette.append( Farbe(43,101,129))  
		palette.append( Farbe(31,71,145))  
		
	elif n>=12:
		palette.append( Farbe(205,133,63)) 
		palette.append( Farbe(255,165,0))  
		palette.append( Farbe(255,215,0))  
		palette.append( Farbe(255,255,000))  
		
		palette.append( Farbe(186,237,0)) 
		palette.append( Farbe(111,254,38))  

		
		palette.append( Farbe(0,205,102))  # 7
		palette.append( Farbe(2,220,0))  
		palette.append( Farbe(2,186,0))  
		
		
		palette.append( Farbe(0,134,139))  
		palette.append( Farbe(43,101,129))  
		palette.append( Farbe(31,71,145))  
	
	return palette
	
	

def createPaletteLandCover(n):
	palette=[]
	if n<=2:
		palette.append( Farbe(255,236,139)) 
		palette.append( Farbe(1,100,0)) 
	elif n==3:
		palette.append( Farbe(255,236,139)) 
		palette.append( Farbe(162,205,90)) 
		palette.append( Farbe(1,100,0)) 
		
	elif n==4:
		palette.append( Farbe(255,236,139)) 
		palette.append( Farbe(205,173,0)) 
		palette.append( Farbe(0,205,0)) 		
		palette.append( Farbe(1,100,0)) 

	elif n==5:
		palette.append( Farbe(255,236,139)) 
		palette.append( Farbe(238,154,73)) 
		palette.append( Farbe(162,205,90)) 
		palette.append( Farbe(69,139,0)) 		
		palette.append( Farbe(1,100,0)) 
		
	elif n==6:
		palette.append( Farbe(255,236,139)) 
		palette.append( Farbe(238,201,0)) 
		palette.append( Farbe(205,190,112)) 
		palette.append( Farbe(154,205,50)) 
		palette.append( Farbe(122,138,52)) 		
		palette.append( Farbe(1,100,0)) 
		
	elif n==7:
		palette.append( Farbe(255,236,139)) 
		palette.append( Farbe(238,201,0)) 
		palette.append( Farbe(205,173,0)) 
		palette.append( Farbe(162,205,90)) 
		palette.append( Farbe(0,205,0)) 
		palette.append( Farbe(122,138,52)) 
		palette.append( Farbe(1,100,0)) 
		
	elif n==8:
		palette.append( Farbe(255,236,139)) 	
		palette.append( Farbe(254,200,124)) 
		palette.append( Farbe(238,201,0)) 
		palette.append( Farbe(205,173,0)) 
		palette.append( Farbe(162,205,90)) 
		palette.append( Farbe(0,205,0)) 		
		palette.append( Farbe(122,138,52)) 
		palette.append( Farbe(1,100,0)) 
		
	elif n==9:
		palette.append( Farbe(255,236,139)) 	
		palette.append( Farbe(254,200,124)) 
		palette.append( Farbe(238,201,0)) 
		palette.append( Farbe(205,173,0)) 
		palette.append( Farbe(162,205,90)) 
		palette.append( Farbe(0,205,0))	
		palette.append( Farbe(122,138,52)) 
		palette.append( Farbe(1,130,0)) 		
		palette.append( Farbe(1,100,0)) 
		
	elif n==10:
		palette.append( Farbe(255,236,139)) 	
		palette.append( Farbe(254,200,124)) 
		palette.append( Farbe(238,201,0)) 
		palette.append( Farbe(205,173,0)) 
		palette.append( Farbe(162,205,90)) 
		palette.append( Farbe(154,205,50)) 
		palette.append( Farbe(0,205,0))	
		palette.append( Farbe(122,138,52)) 
		palette.append( Farbe(1,130,0)) 		
		palette.append( Farbe(1,100,0)) 

	elif n==11:
		palette.append( Farbe(255,236,139)) 	
		palette.append( Farbe(254,200,124)) 
		palette.append( Farbe(238,201,0)) 
	
		palette.append( Farbe(205,173,0)) 
		palette.append( Farbe(205,190,112)) 
		
		palette.append( Farbe(162,205,90)) 
		palette.append( Farbe(154,205,50)) 
		palette.append( Farbe(0,205,0))	
		palette.append( Farbe(122,138,52)) 
		palette.append( Farbe(1,130,0)) 		
		palette.append( Farbe(1,100,0)) 
		
		
	elif n>=12:
		palette.append( Farbe(255,236,139)) 	
		palette.append( Farbe(254,200,124)) 
		palette.append( Farbe(238,201,0)) 
		palette.append( Farbe(238,154,73)) 
		palette.append( Farbe(205,173,0)) 		
		palette.append( Farbe(205,190,112)) 		
		palette.append( Farbe(162,205,90)) 
		palette.append( Farbe(154,205,50)) 
		palette.append( Farbe(0,205,0))	
		palette.append( Farbe(122,138,52)) 
		palette.append( Farbe(1,130,0)) 		
		palette.append( Farbe(1,100,0)) 		
	
	return palette		
	
	
def createPaletteGelbGruenDunkelblau(n):
	palette=[]
	if n<=2:
		palette.append( Farbe(255,255,000)) 
		palette.append( Farbe(13,0,130)) 
	elif n==3:
		palette.append( Farbe(255,255,000)) 
		palette.append( Farbe(2,234,0)) 
		palette.append( Farbe(13,0,130)) 
		
	elif n==4:
		palette.append( Farbe(255,255,000)) 
		palette.append( Farbe(116,254,0)) 
		palette.append( Farbe(0,219,153)) 
		palette.append( Farbe(13,0,130)) 

	elif n==5:
		palette.append( Farbe(255,255,000)) 	
		palette.append( Farbe(169,254,0)) 
		palette.append( Farbe(2,234,0)) 
		palette.append( Farbe(0,169,138)) 		
		palette.append( Farbe(13,0,130)) 
		
	elif n==6:
		palette.append( Farbe(255,255,000))
		palette.append( Farbe(205,254,0)) 
		palette.append( Farbe(62,254,0)) 
		palette.append( Farbe(0,221,102)) 
		palette.append( Farbe(0,135,165)) 		
		palette.append( Farbe(13,0,130)) 
		
	elif n==7:
		palette.append( Farbe(255,255,000))
		palette.append( Farbe(205,254,0)) 
		palette.append( Farbe(116,254,0)) 
		palette.append( Farbe(2,234,0)) 		
		palette.append( Farbe(0,219,153)) 
		palette.append( Farbe(0,135,165)) 		
		palette.append( Farbe(13,0,130)) 
		
	elif n==8:
		palette.append( Farbe(255,255,000))
	
		palette.append( Farbe(229,254,0)) 
		palette.append( Farbe(205,254,0)) 
		palette.append( Farbe(116,254,0)) 
		palette.append( Farbe(2,234,0)) 
		palette.append( Farbe(0,219,153)) 
		palette.append( Farbe(0,135,165)) 		
		palette.append( Farbe(13,0,130)) 
		
	elif n==9:
		palette.append( Farbe(255,255,000))
		palette.append( Farbe(229,254,0)) 
		palette.append( Farbe(205,254,0)) 
		palette.append( Farbe(116,254,0)) 
		palette.append( Farbe(2,234,0)) 
		palette.append( Farbe(0,219,153)) 
		palette.append( Farbe(0,135,165)) 
		palette.append( Farbe(0,80,165)) 		
		palette.append( Farbe(13,0,130)) 
		
	elif n==10:
		palette.append( Farbe(255,255,000))
		palette.append( Farbe(229,254,0)) 
		palette.append( Farbe(205,254,0)) 
		palette.append( Farbe(116,254,0)) 
		palette.append( Farbe(2,234,0)) 
		palette.append( Farbe(0,221,102)) 
		palette.append( Farbe(0,219,153)) 
		palette.append( Farbe(0,135,165)) 
		palette.append( Farbe(0,80,165)) 		
		palette.append( Farbe(13,0,130)) 

	elif n==11:
		palette.append( Farbe(255,255,000))		
		palette.append( Farbe(229,254,0)) 
		palette.append( Farbe(205,254,0)) 
		palette.append( Farbe(116,254,0)) 
		palette.append( Farbe(62,254,0)) 
		palette.append( Farbe(2,234,0)) 
		palette.append( Farbe(0,221,102)) 
		palette.append( Farbe(0,219,153)) 
		palette.append( Farbe(0,135,165)) 
		palette.append( Farbe(0,80,165)) 		
		palette.append( Farbe(13,0,130)) 
		
	elif n>=12:
		diff = n/3
		n1 = diff-1
		if n1==0:
			n1=1
		n2 = diff-1
		if n2==0:
			n2=1
		n3 = n- n1- n2
		createPalette(palette, 255,255, 255,255, 220, 135, n1)  # bis hellgelb
		
		createPalette(palette, 180,0, 255,244, 180, 0, n2)  # hell grün
		
		createPalette(palette, 120,0,  120,0, 255, 150, n3)  # blau

		
		
	return palette

def createPalette(palette, r1, r2, g1, g2, b1, b2, n):
		r=r1
		g=g1
		b=b1
		
		iR=(r-r2)/n
		iG=(g-g2)/n
		iB=(b-b2)/n
		i=0		
		while i<n:
			#print(2,r,g,b)
			palette.append( Farbe(r,g,b))  
			r-=iR
			g-=iG
			b-=iB
			if r>255:
				r=255
			if g>255:
				g=255
			if b>255:
				b=255
			if r<0:
				r=0
			if g<0:
				g=0
			if b<0:
				b=0
			i+=1
	
	
	
def createPaletteGruenBrauner(n):
	palette=[]
	if n<=2:
		palette.append( Farbe(0,255,000)) 
		palette.append( Farbe(128,64,0)) 
	elif n==3:
		palette.append( Farbe(94,255,94)) 
		palette.append( Farbe(0,193,000)) 
		palette.append( Farbe(128,64,0)) 
	elif n==4:
		palette.append( Farbe(94,255,94)) 
		palette.append( Farbe(0,193,000)) 
		palette.append( Farbe(253,126,0)) 
		palette.append( Farbe(128,64,0)) 

	elif n==5:
		palette.append( Farbe(94,255,94)) 
		palette.append( Farbe(0,193,000)) 

		palette.append( Farbe(255,190,125)) 
		palette.append( Farbe(255,135,15)) 
		palette.append( Farbe(128,64,0)) 
		
	elif n==6:
		palette.append( Farbe(89,255,89)) 
		palette.append( Farbe(0,240,00)) 
		palette.append( Farbe(0,185,00)) 

		palette.append( Farbe(255,190,125)) 
		palette.append( Farbe(255,135,15)) 
		palette.append( Farbe(128,64,0)) 

		
	else:
		n1 = n>>1		
		if n1==0:
			n1=1			
		n2= n -n1
		
		n2Halbe = n1>>1
		if n2Halbe==0:
			n2Halbe=1		

		iR=(140)/n2Halbe
		iG=(225-128)/(n1)
		iB=(140)/n2Halbe
		
		r=140
		g=255
		b=140
		i=0
		while i<n1:
			palette.append( Farbe(r,g,b))  
			r-=iR
			g-=iG
			b-=iB
			if r>255:
				r=255
			if g>255:
				g=255
			if b>255:
				b=255
			if r<0:
				r=0
			if g<0:
				g=0
			if b<0:
				b=0
			i+=1
			
		
		r=255
		g=210
		b=170
		
		iR=(r-128)/n2
		iG=(g-64)/n2
		iB=(b)/n2
		
		i=0		
		while i<n2:
			if i<n2Halbe:
				b=0
			

			palette.append( Farbe(r,g,b))  
			r-=iR
			g-=iG
			b-=iB
			if r>255:
				r=255
			if g>255:
				g=255
			if b>255:
				b=255
			if r<0:
				r=0
			if g<0:
				g=0
			if b<0:
				b=0
			i+=1
		
	return palette
	


def createPaletteRoterFarbverlauf(n):
	palette=[]
	createPalette(palette, 255, 193,  176,0, 176, 0, n)  # rot
	return palette
	
def createPaletteBlauerFarbverlauf(n):
	palette=[]	
	createPalette(palette, 176,0,  176,0, 255, 193, n)  # blau
	return palette
	
	
def createPaletteGruenerFarbverlauf(n):
	palette=[]
	createPalette(palette, 176,0,   255,193,   176,0, n)  # grün
	return palette
	
	
# "hellrot", "rot","hellblau", 'blau','hellgrün', 'grün','helllila', 'lila','hellorange', 'orange'	 ]
	
	
def createPaletteBraunerFarbverlauf(n):
	palette=[]
	iR=(255-134)/(n+2)
	iG=(255-113)/(n+2)
	iB=(225-0)/(n+2)
	r=256-iR
	g=256-iG
	b=256-iB
	i=0
	while r>0 and g>0 and b>0 and i<n:
		palette.append( Farbe(r,g,b))  
		r-=iR
		g-=iG
		b-=iB
		i+=1
	return palette

	
	
	

def createPaletteDummy(n):
	palette=[]
	if n<=2:
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
	elif n==3:
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		
	elif n==4:
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 

	elif n==5:
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		
	elif n==6:
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		
	elif n==7:
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		
	elif n==8:
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		
	elif n==9:
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		
	elif n==10:
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 

	elif n==11:
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		
	elif n>=12:
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		palette.append( Farbe(000,000,000)) 
		
	
	return palette		
	

def createHellrot(n):
	palette=[]
	r=255
	g=127
	b=127
	for i in range(n):
		palette.append( Farbe(r,g,b))  
	return palette
	
def createRot(n):
	palette=[]
	r=255
	g=0
	b=0
	for i in range(n):
		palette.append( Farbe(r,g,b))  
	return palette		

def createHellblau(n):
	palette=[]
	r=127
	g=127
	b=255
	for i in range(n):
		palette.append( Farbe(r,g,b))  
	return palette
	
def createBlau(n):
	palette=[]
	r=0
	g=0
	b=255
	for i in range(n):
		palette.append( Farbe(r,g,b))  
	return palette		
	
def createHellgruen(n):
	palette=[]
	r=127
	g=255
	b=127
	for i in range(n):
		palette.append( Farbe(r,g,b))  
	return palette
	
def createGruen(n):
	palette=[]
	r=0
	g=255
	b=0
	for i in range(n):
		palette.append( Farbe(r,g,b))  
	return palette		
	
		
def createHelllila(n):
	palette=[]
	r=255
	g=127
	b=255
	for i in range(n):
		palette.append( Farbe(r,g,b))  
	return palette
	
def createLila(n):
	palette=[]
	r=255
	g=0
	b=255
	for i in range(n):
		palette.append( Farbe(r,g,b))  
	return palette		
	
def createHellorange(n):
	palette=[]
	r=255
	g=181
	b=106
	for i in range(n):
		palette.append( Farbe(r,g,b))  
	return palette
	
def createOrange(n):
	palette=[]
	r=255
	g=128
	b=0
	for i in range(n):
		palette.append( Farbe(r,g,b))  
	return palette		

	
def createPaletteGray(n):
	palette=[]
	intv=255/(n+2)
	rgb=255-intv
	i=0
	#print(rgb,intv)
	while rgb>0  and i<n:
		#print(rgb,i)
		palette.append( Farbe(rgb,rgb,rgb))  
		rgb-=intv
		i+=1
	return palette
