import os

from qgis.PyQt import uic
from qgis.PyQt import QtWidgets, QtGui, QtCore


from qgis.PyQt.QtWidgets import QWidget, QListWidget, QListWidgetItem, QAction, QVBoxLayout, QToolButton, QMenu

from PyQt5.QtGui import QCursor, QStandardItem, QStandardItemModel



FORM_CLASS, _ = uic.loadUiType(os.path.join(
	os.path.dirname(__file__), 'uilegendkategorie.ui'))



class uiLegendKategorie(QtWidgets.QDialog, FORM_CLASS):
	def __init__(self, parent= None):

		super(uiLegendKategorie, self).__init__(parent)
		self.setupUi(self)		
		self.chkSichtbar.stateChanged.connect(self.chkSichtbarStateChanged)
		
		self.rbIntervall.toggled.connect(self.rbIntervallStateChanged)
		self.rbAnzahlStufen.toggled.connect(self.rbAnzahlStufenStateChanged)
		
		self.minValueSichtbar=0
		self.maxValueSichtbar=0
		self.minValueAlle=0
		self.maxValueAlle=0
		self.listeAllerLayer=None
		self.listeSichtbarerLayer=None
		
	def setValues(self, listeAllerLayer,listeSichtbarerLayer, minValueSichtbar,maxValueSichtbar,minValueAlle,maxValueAlle):
		self.minValueSichtbar=minValueSichtbar
		self.maxValueSichtbar=maxValueSichtbar
		self.minValueAlle=minValueAlle
		self.maxValueAlle=maxValueAlle
		self.listeAllerLayer=listeAllerLayer
		self.listeSichtbarerLayer=listeSichtbarerLayer
		
	def rbIntervallStateChanged(self,newValue):
		self.rb01.setEnabled(True)
		self.rb05.setEnabled(True)
		self.rb1.setEnabled(True)
		self.rb2.setEnabled(True)
		self.rb3.setEnabled(True)
		self.rb4.setEnabled(True)
		self.rb5.setEnabled(True)
		self.rb10.setEnabled(True)
		self.cbAnzIntervalle.setEnabled(False)
	
	def rbAnzahlStufenStateChanged(self,newValue):
		self.rb01.setEnabled(False)
		self.rb05.setEnabled(False)
		self.rb1.setEnabled(False)
		self.rb2.setEnabled(False)
		self.rb3.setEnabled(False)
		self.rb4.setEnabled(False)
		self.rb5.setEnabled(False)
		self.rb10.setEnabled(False)
		self.cbAnzIntervalle.setEnabled(True)
	
	def chkSichtbarStateChanged(self,  newState):
		#QMessageBox.information(self.iface.mainWindow(),u"Hinweis", u"Klicked")
		if newState:
			str_minValue=u"{0:.2f}".format(float(self.minValueSichtbar))
			str_maxValue=u"{0:.2f}".format(float(self.maxValueSichtbar))
			hoehenliste=self.listeSichtbarerLayer
		else:
			str_minValue=u"{0:.2f}".format(float(self.minValueAlle))
			str_maxValue=u"{0:.2f}".format(float(self.maxValueAlle))
			hoehenliste=self.listeAllerLayer
			
		self.tMin.setText(str_minValue)
		self.tMinVorgabe.setText(str_minValue)
		self.tMax.setText(str_maxValue)
		self.tMaxVorgabe.setText(str_maxValue)
		
		model = QStandardItemModel(self.listView)
		for layername in hoehenliste:
			item = QStandardItem(layername)
			item.setCheckable(True)		# Add a checkbox to it
			model.appendRow(item)			# Add the item to the model
		self.listView.setModel(model)				
		
