import os

from qgis.PyQt import uic
from qgis.PyQt import QtWidgets, QtGui, QtCore


from qgis.PyQt.QtWidgets import QWidget, QListWidget, QListWidgetItem, QAction, QVBoxLayout, QToolButton, QMenu

from PyQt5.QtGui import QCursor, QStandardItem, QStandardItemModel

FORM_CLASS, _ = uic.loadUiType(os.path.join(
	os.path.dirname(__file__), 'uilegendrangecolor.ui'))

from .paletten import *


class uiLegendRangeColor(QtWidgets.QDialog, FORM_CLASS):
	def __init__(self, parent= None):

		super(uiLegendRangeColor, self).__init__(parent)
		self.setupUi(self)		
		
		self.strichdicken = ["0.1","0.2","0.3","0.4","0.5","0.6","0.7","0.8","0.9",
            "1.0","1.2","1.3","1.4","1.5","1.6","1.7","1.8","1.9",
            "2.0","2.2","2.3","2.4","2.5","2.6","2.7","2.8","2.9",
            "3.0","3.2","3.3","3.4","3.5","3.6","3.7","3.8","3.9","4.0"]
		
		self.listeIntervalle12 = ["2","3","4","5","6","7","8","9","10","11","12"]
		self.listeIntervalle20 = ["2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20"]

		self.farbpalette = ['Niederschlag (12 Farben)','LandCover (12 Farben)',\
		    'Gelb,Grün,Dunkelblau Farbverlauf',  'Grün,brauner Farbverlauf',\
		    'blauer Farbverlauf', 'roter Farbverlauf','brauner Farbverlauf','grüner Farbverlauf','grauer Farbverlauf',\
		     'alles hellrot', 'alles rot','alles hellblau', 'alles blau',u'alles hellgrün',\
	         u'alles grün','alles helllila', 'alles lila','alles hellorange', 'alles orange'	 ]
		
		
		self.anzIntervalle=0
		self.maxPaletten=12
		
		
		self.rbIntervall.toggled.connect(self.onChangeRbIntervall)
		self.rbAnzahlStufen.toggled.connect(self.rbAnzahlStufenStateChanged)
		
		
		self.tMin.textChanged.connect(self.checkMinMaxValues)
		self.tMax.textChanged.connect(self.checkMinMaxValues)
		
		self.rb01.toggled.connect(self.checkRbIntervalleValues)
		self.rb05.toggled.connect(self.checkRbIntervalleValues)
		self.rb1.toggled.connect(self.checkRbIntervalleValues)
		self.rb2.toggled.connect(self.checkRbIntervalleValues)
		self.rb3.toggled.connect(self.checkRbIntervalleValues)
		self.rb4.toggled.connect(self.checkRbIntervalleValues)
		self.rb5.toggled.connect(self.checkRbIntervalleValues)
		self.rb10.toggled.connect(self.checkRbIntervalleValues)

		self.rb20.toggled.connect(self.checkRbIntervalleValues)
		self.rb50.toggled.connect(self.checkRbIntervalleValues)
		self.rb100.toggled.connect(self.checkRbIntervalleValues)
		self.rb250.toggled.connect(self.checkRbIntervalleValues)
		self.rb500.toggled.connect(self.checkRbIntervalleValues)
		self.rb1000.toggled.connect(self.checkRbIntervalleValues)
		self.rb2500.toggled.connect(self.checkRbIntervalleValues)
		self.rb5000.toggled.connect(self.checkRbIntervalleValues)
		
		# die Anzahl wird gesetzt durch PalettenChange !
		self.cbAnzIntervalle.currentIndexChanged.connect(self.cbAnzIntervalleStateChanged) 
		
		self.cbFarbpalette.currentIndexChanged.connect(self.cbFarbpaletteStateChanged)  
		# self.dlg.comboBoxTransf.currentIndexChanged.connect(self.selectionchange)

		self.chkUmdrehen.stateChanged.connect(self.chkUmdrehenStateChanged)
		
		self.minValueAlle=0
		self.maxValueAlle=0
		self.listeAllerLayer=None
		
		self.labelError.setText('');
		qpalette = QtGui.QPalette()
		brush = QtGui.QBrush(QtGui.QColor(255,0,0))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		qpalette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.grfError.setPalette(qpalette)
		self.grfError.setAutoFillBackground(True)		
		self.grfError.setEnabled(False)
		
			

	def setValues(self, listeAllerLayer,minValueAlle,maxValueAlle):
	
		model = QStandardItemModel(self.cbFarbpalette)
		for bez in self.farbpalette:
			item = QStandardItem(bez)
			model.appendRow(item)
		self.cbFarbpalette.setModel(model)
		self.cbFarbpalette.setCurrentIndex(0)
		
		self.cbFarbpaletteStateChanged(0)
		
		
		model = QStandardItemModel(self.cbMinStrichdicke)
		for dicke in self.strichdicken:
			item = QStandardItem(dicke)
			model.appendRow(item)
		self.cbMinStrichdicke.setModel(model)
		self.cbMinStrichdicke.setCurrentIndex(3)
		
		model = QStandardItemModel(self.cbMaxStrichdicke)
		for dicke in self.strichdicken:
			item = QStandardItem(dicke)
			model.appendRow(item)
		self.cbMaxStrichdicke.setModel(model)
		self.cbMaxStrichdicke.setCurrentIndex(3)
		
		
		self.cbFarbpaletteStateChanged(0)
		
	
		self.minValueAlle=minValueAlle
		self.maxValueAlle=maxValueAlle
		self.listeAllerLayer=listeAllerLayer
		
		str_minValue=u"{0:.2f}".format(float(self.minValueAlle))
		str_maxValue=u"{0:.2f}".format(float(self.maxValueAlle))
			
		self.tMin.setText(str_minValue)
		self.tMinVorgabe.setText(str_minValue)
		self.tMax.setText(str_maxValue)
		self.tMaxVorgabe.setText(str_maxValue)
		
		self.calcIntervall()
	
	def checkMinMaxValues(self, newValue):
		self.calcIntervall()
		

	
	
	def cbFarbpaletteStateChanged(self,newIndex):
		if newIndex<2:
			model = QStandardItemModel(self.cbAnzIntervalle)
			for anzInt in self.listeIntervalle12:
				item = QStandardItem(anzInt)
				model.appendRow(item)
			self.cbAnzIntervalle.setModel(model)
			self.cbAnzIntervalle.setCurrentIndex(10)
			self.maxPaletten=12			
		else:
			model = QStandardItemModel(self.cbAnzIntervalle)
			for anzInt in self.listeIntervalle20:
				item = QStandardItem(anzInt)
				model.appendRow(item)
			self.cbAnzIntervalle.setModel(model)
			self.cbAnzIntervalle.setCurrentIndex(18)
			self.maxPaletten=20		
			
			
		#self.calcIntervall()
		self.showColors()
		
		
		
		#print('setAnzahlIntervalleAusFarbpalette','self.maxPaletten',self.maxPaletten)
	
	def cbAnzIntervalleStateChanged(self, newIndex):
		index = self.cbAnzIntervalle.currentIndex()
		if index>=0:
			self.anzIntervalle=index+2	
			self.showColors()
		
	def chkUmdrehenStateChanged(self,  newState):
		self.showColors()
	
	def checkRbIntervalleValues(self,newValue):
		self.calcIntervall()	
	

			
	def clearAlleGrf(self):
		grfs = [self.grf1,self.grf2,self.grf3,self.grf4,self.grf5,self.grf6,self.grf7,self.grf8,self.grf9,self.grf10,self.grf11,self.grf12]
		for grf in grfs:
			grf.setEnabled(False)
	

			
			
		
	def onChangeRbIntervall(self,newValue):
		self.rbSetRadioButtons(True)
	
	def rbAnzahlStufenStateChanged(self,newValue):
		self.rbSetRadioButtons(False)
		index = self.cbAnzIntervalle.currentIndex()
		if index>=0:
			self.anzIntervalle=index+2	
			self.showColors()
		
		
	def rbSetRadioButtons(self,newValue):
		self.rb01.setEnabled(newValue)
		self.rb05.setEnabled(newValue)
		self.rb1.setEnabled(newValue)
		self.rb2.setEnabled(newValue)
		self.rb3.setEnabled(newValue)
		self.rb4.setEnabled(newValue)
		self.rb5.setEnabled(newValue)
		self.rb10.setEnabled(newValue)
		self.rb10.setEnabled(newValue)
		self.rb20.setEnabled(newValue)
		self.rb50.setEnabled(newValue)
		self.rb100.setEnabled(newValue)
		self.rb250.setEnabled(newValue)
		self.rb500.setEnabled(newValue)
		self.rb1000.setEnabled(newValue)
		self.rb2500.setEnabled(newValue)
		self.rb5000.setEnabled(newValue)
		self.cbAnzIntervalle.setEnabled(not newValue)
		#if not newValue:
			
		self.calcIntervall()		
		
		
	def calcIntervall(self):
		self.setError('')
		
		self.tIntervall.setText("")
		self.anzIntervalle=-1
		if self.rbIntervall.isChecked():
			intervall = None
			if self.rb01.isChecked():
				intervall=0.1
			elif self.rb05.isChecked():
				intervall=0.5
			elif self.rb1.isChecked():
				intervall=1
			elif self.rb2.isChecked():
				intervall=2
			elif self.rb3.isChecked():
				intervall=3
			elif self.rb4.isChecked():
				intervall=4
			elif self.rb5.isChecked():
				intervall=5
			elif self.rb10.isChecked():
				intervall=10
			elif self.rb20.isChecked():
				intervall=20
			elif self.rb100.isChecked():
				intervall=100
			elif self.rb250.isChecked():
				intervall=250
			elif self.rb500.isChecked():
				intervall=500
			elif self.rb1000.isChecked():
				intervall=1000
			elif self.rb2500.isChecked():
				intervall=2500
			elif self.rb500.isChecked():
				intervall=500
			elif self.rb5000.isChecked():
				intervall=5000
				
			if intervall==None:
				self.clearAlleGrf()
				return	
				
			minValue = self.checkInput(self.tMin.text())
			if minValue==None:
				self.clearAlleGrf()
				return					
			maxValue = self.checkInput(self.tMax.text())
			if maxValue==None:
				self.clearAlleGrf()
				self.setError('Fehler: Das gewählte Intervall konnte nicht ermittelt werden')
				return
			
			if minValue>=maxValue:
				self.clearAlleGrf()
				return

			hoehe = minValue
			anzIntervalle=0
			while hoehe<=maxValue+intervall*0.1:
				anzIntervalle+=1
				hoehe+=intervall		
			self.tIntervall.setText(str(anzIntervalle))
			
			#print('calcIntervall','anzIntervalle',anzIntervalle,'self.maxPaletten',self.maxPaletten)
			if anzIntervalle>self.maxPaletten:
				self.setError('Fehler: Das gewählte Intervall ist zu klein. Maximal sind '+str(self.maxPaletten)+' erlaubt')
				#print('Fehler: Das gewählte Intervall ist zu klein. Maximal sind '+str(self.maxPaletten)+' erlaubt')
				self.anzIntervalle = self.maxPaletten
			else:
				self.anzIntervalle = anzIntervalle
				self.setError('')
			
		self.showColors()
		

	def setError(self, errorText):
		if len(errorText)==0:
			self.labelError.setText('')
			self.grfError.setEnabled(False)
		else:		
			self.grfError.setEnabled(True)
			self.labelError.setText(errorText)
			
	

		
		
		# Aufruf durch changeFarbpalette, rbAbstände, calcIntervall, min, max
	def showColors(self):
		self.setError('')
		minValue = self.checkInput(self.tMin.text())
		if minValue==None:
			return					
		maxValue = self.checkInput(self.tMax.text())
		if maxValue==None:
			return
		
		
		palettenIndex =  self.cbFarbpalette.currentIndex()
		if palettenIndex<2:
			self.maxPaletten=12
		else:
			self.maxPaletten=20
		
		anzIntervalle=-1
		if self.rbIntervall.isChecked():
			intervall = None
			if self.rb01.isChecked():
				intervall=0.1
			elif self.rb05.isChecked():
				intervall=0.5
			elif self.rb1.isChecked():
				intervall=1
			elif self.rb2.isChecked():
				intervall=2
			elif self.rb3.isChecked():
				intervall=3
			elif self.rb4.isChecked():
				intervall=4
			elif self.rb5.isChecked():
				intervall=5
			elif self.rb10.isChecked():
				intervall=10

			elif self.rb20.isChecked():
				intervall=20
			elif self.rb50.isChecked():
				intervall=50
			elif self.rb100.isChecked():
				intervall=100
			elif self.rb250.isChecked():
				intervall=250
			elif self.rb500.isChecked():
				intervall=500
			elif self.rb1000.isChecked():
				intervall=1000
			elif self.rb2500.isChecked():
				intervall=2500
			elif self.rb5000.isChecked():
				intervall=5000


			if intervall==None:
				return
			
			if intervall>maxValue-minValue:
				return

			
			hoehe = minValue
			self.anzIntervalle=0
			while hoehe<=maxValue+intervall*0.1:
				self.anzIntervalle+=1
				hoehe+=intervall				
			
			
		
			if self.anzIntervalle>self.maxPaletten:
				self.setError('Fehler: Das gewählte Intervall ist zu klein. Momentan sind maximal '+str(self.maxPaletten)+' Farben erlaubt')
				return
		else:
			index = self.cbAnzIntervalle.currentIndex()
			if index<0:
				return
			self.anzIntervalle=index+2		
		
	
		if self.anzIntervalle>self.maxPaletten:
			self.anzIntervalle=self.maxPaletten
			
		
		anzIntervalle = self.anzIntervalle
		palettenIndex =  self.cbFarbpalette.currentIndex()
		palette=[]
		if palettenIndex==0:
			palette = createPaletteNiederschlag(anzIntervalle)
		elif palettenIndex==1:
			palette = createPaletteLandCover(anzIntervalle)
			
		elif palettenIndex==2:
			palette = createPaletteGelbGruenDunkelblau(anzIntervalle)
			
			
		elif palettenIndex==3:
			palette = createPaletteGruenBrauner(anzIntervalle)

			
		elif palettenIndex==4:
			palette = createPaletteBlauerFarbverlauf(anzIntervalle)
		elif palettenIndex==5:
			palette = createPaletteRoterFarbverlauf(anzIntervalle)
		elif palettenIndex==6:
			palette = createPaletteBraunerFarbverlauf(anzIntervalle)
		elif palettenIndex==7:
			palette = createPaletteGruenerFarbverlauf(anzIntervalle)
		elif palettenIndex==8:
			palette = createPaletteGray(anzIntervalle)

			
		elif palettenIndex==9:
			palette = createHellrot(anzIntervalle)
		elif palettenIndex==10:
			palette = createRot(anzIntervalle)
		elif palettenIndex==11:
			palette = createHellblau(anzIntervalle)
		elif palettenIndex==12:
			palette = createBlau(anzIntervalle)
		elif palettenIndex==13:
			palette = createHellgruen(anzIntervalle)
		elif palettenIndex==14:
			palette = createGruen(anzIntervalle)
		elif palettenIndex==15:
			palette = createHelllila(anzIntervalle)
		elif palettenIndex==16:
			palette = createLila(anzIntervalle)
		elif palettenIndex==17:
			palette = createHellorange(anzIntervalle)
		elif palettenIndex==18:
			palette = createOrange(anzIntervalle)
			
		else:
			palette = createPaletteGray(anzIntervalle)
			
			
#"hellrot", "rot","hellblau", 'blau','hellgrün', 'grün','helllila', 'lila','hellorange', 'orange'	 ]			
		
		
			
		if self.chkUmdrehen.isChecked():
			palette.reverse()
		
		grfs = [self.grf1,self.grf2,self.grf3,self.grf4,self.grf5,self.grf6,self.grf7,self.grf8,self.grf9,self.grf10,self.grf11,self.grf12,self.grf13,self.grf14,self.grf15,self.grf16,self.grf17,self.grf18,self.grf19,self.grf20]
		index=0
		while index<self.anzIntervalle:
			qpalette = QtGui.QPalette()
			brush = QtGui.QBrush(QtGui.QColor(palette[index].r,palette[index].g,palette[index].b))
			brush.setStyle(QtCore.Qt.SolidPattern)		
			qpalette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
			grfs[index].setPalette(qpalette)
			grfs[index].setAutoFillBackground(True)		
			grfs[index].setEnabled(True)
			index+=1
			
		index=self.anzIntervalle
		while index<20:
			grfs[index].setEnabled(False)
			index+=1
			
		#self.calcIntervall()
		
		
		
		
		

	def toFloat(self,sValue):
		try:
			value=float(sValue)
			return value
		except:
			return None
		
	def checkInputPositiv(self,str_input):
		input = self.toFloat(str_input)		# oder basis.toFloat(dummy)
		if input==None:
			return None					
		if input<0.0:
			return None
		return input			
		
		
	def checkInput(self,str_input):
		input = self.toFloat(str_input)		# oder basis.toFloat(dummy)
		if input==None:
			return None					
		return input							