import os

from qgis.PyQt import uic
from qgis.PyQt import QtWidgets, QtGui, QtCore


from qgis.PyQt.QtWidgets import QWidget, QListWidget, QListWidgetItem, QAction, QVBoxLayout, QToolButton, QMenu

from PyQt5.QtGui import QCursor, QStandardItem, QStandardItemModel


FORM_CLASS, _ = uic.loadUiType(os.path.join(
	os.path.dirname(__file__), 'uiselectcolor.ui'))




class uiSelectColor(QtWidgets.QDialog, FORM_CLASS):
	def __init__(self, parent= None):

		super(uiSelectColor, self).__init__(parent)

		self.setupUi(self)
		
		self.sliderRed.valueChanged.connect(self.sliderRedStateChanged)
		self.sliderGreen.valueChanged.connect(self.sliderGreenStateChanged)
		self.sliderBlue.valueChanged.connect(self.sliderBlueStateChanged)
		
		self.tRed.textChanged.connect(self.tRedtextChanged)
		self.tGreen.textChanged.connect(self.tGreentextChanged)
		self.tBlue.textChanged.connect(self.tBluetextChanged)
		

		palette = QtGui.QPalette()
		brush = QtGui.QBrush(QtGui.QColor(255, 255, 128))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		palette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.bnLightYellow.setPalette(palette)
		self.bnLightYellow.setAutoFillBackground(True)		
		
		palette = QtGui.QPalette()
		brush = QtGui.QBrush()
		brush = QtGui.QBrush(QtGui.QColor(255, 255, 0))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		palette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.bnYellow.setPalette(palette)
		self.bnYellow.setAutoFillBackground(True)		
		
		palette = QtGui.QPalette()
		brush = QtGui.QBrush(QtGui.QColor(255, 182, 108))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		palette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.bnLightOrange.setPalette(palette)
		self.bnLightOrange.setAutoFillBackground(True)		
		
		palette = QtGui.QPalette()
		brush = QtGui.QBrush(QtGui.QColor(255, 128, 0))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		palette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.bnOrange.setPalette(palette)
		self.bnOrange.setAutoFillBackground(True)		


		palette = QtGui.QPalette()
		brush = QtGui.QBrush(QtGui.QColor(128, 255, 0))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		palette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.bnLightGreen.setPalette(palette)
		self.bnLightGreen.setAutoFillBackground(True)		
		
		palette = QtGui.QPalette()
		brush = QtGui.QBrush(QtGui.QColor(0, 255, 0))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		palette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.bnGreen.setPalette(palette)
		self.bnGreen.setAutoFillBackground(True)		
		
		

		palette = QtGui.QPalette()
		brush = QtGui.QBrush(QtGui.QColor(70, 70, 255))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		palette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.bnLightBlue.setPalette(palette)
		self.bnLightBlue.setAutoFillBackground(True)		
		
		palette = QtGui.QPalette()
		brush = QtGui.QBrush(QtGui.QColor(0, 0, 255))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		palette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.bnBlue.setPalette(palette)
		self.bnBlue.setAutoFillBackground(True)		
				
				

		palette = QtGui.QPalette()
		brush = QtGui.QBrush(QtGui.QColor(255, 90, 90))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		palette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.bnLightRed.setPalette(palette)
		self.bnLightRed.setAutoFillBackground(True)		
		
		palette = QtGui.QPalette()
		brush = QtGui.QBrush(QtGui.QColor(255, 0, 0))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		palette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.bnRed.setPalette(palette)
		self.bnRed.setAutoFillBackground(True)		
								
														

		palette = QtGui.QPalette()
		brush = QtGui.QBrush(QtGui.QColor(255, 128, 191))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		palette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.bnLightViolett.setPalette(palette)
		self.bnLightViolett.setAutoFillBackground(True)		
		
		palette = QtGui.QPalette()
		brush = QtGui.QBrush(QtGui.QColor(255, 0, 128))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		palette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.bnViolett.setPalette(palette)
		self.bnViolett.setAutoFillBackground(True)		
																								

		palette = QtGui.QPalette()
		brush = QtGui.QBrush(QtGui.QColor(217, 108, 0))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		palette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.bnLightBrown.setPalette(palette)
		self.bnLightBrown.setAutoFillBackground(True)		
		
		palette = QtGui.QPalette()
		brush = QtGui.QBrush(QtGui.QColor(128, 64, 0))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		palette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.bnBrown.setPalette(palette)
		self.bnBrown.setAutoFillBackground(True)		
																									

		palette = QtGui.QPalette()
		brush = QtGui.QBrush(QtGui.QColor(200, 200, 200))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		palette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.bnLightGray.setPalette(palette)
		self.bnLightGray.setAutoFillBackground(True)		
		
		palette = QtGui.QPalette()
		brush = QtGui.QBrush(QtGui.QColor(129, 129, 129))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		palette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.bnGray.setPalette(palette)
		self.bnGray.setAutoFillBackground(True)		
		

		
		self.r=0
		self.g=0
		self.b=0
		self.setColor()
		
		#self.bnLightYellow.mousePressEvent = self.mousePressEvent
		self.bnLightYellow.mouseDoubleClickEvent = self.bnLightYellowmouseDoubleClick
		self.bnYellow.mouseDoubleClickEvent = self.bnYellowmouseDoubleClick
		self.bnLightOrange.mouseDoubleClickEvent = self.bnLightOrangemouseDoubleClick
		self.bnOrange.mouseDoubleClickEvent = self.bnOrangemouseDoubleClick
		self.bnLightGreen.mouseDoubleClickEvent = self.bnLightGreenmouseDoubleClick
		self.bnGreen.mouseDoubleClickEvent = self.bnGreenmouseDoubleClick
		self.bnLightBlue.mouseDoubleClickEvent = self.bnLightBluemouseDoubleClick
		self.bnBlue.mouseDoubleClickEvent = self.bnBluemouseDoubleClick
		self.bnLightRed.mouseDoubleClickEvent = self.bnLightRedmouseDoubleClick
		self.bnRed.mouseDoubleClickEvent = self.bnRedmouseDoubleClick
		self.bnLightViolett.mouseDoubleClickEvent = self.bnLightViolettmouseDoubleClick
		self.bnViolett.mouseDoubleClickEvent = self.bnViolettmouseDoubleClick

		self.bnLightBrown.mouseDoubleClickEvent = self.bnLightBrownmouseDoubleClick
		self.bnBrown.mouseDoubleClickEvent = self.bnBrownmouseDoubleClick

		self.bnLightGray.mouseDoubleClickEvent = self.bnLightGraymouseDoubleClick
		self.bnGray.mouseDoubleClickEvent = self.bnGraymouseDoubleClick
		
		

	def toFloat(self, sValue):
		try:
			value=float(sValue)
			return value
		except:
			return None
			
	def tRedtextChanged(self, newValue):
		red = self.toFloat(newValue)
		if red!=None:
			self.sliderRed.setValue(red)
	
	def tGreentextChanged(self, newValue):
		green = self.toFloat(newValue)
		if green!=None:
			self.sliderGreen.setValue(green)


	def tBluetextChanged(self, newValue):
		blue = self.toFloat(newValue)
		if blue!=None:
			self.sliderBlue.setValue(blue)
			
		
	def bnLightYellowmouseDoubleClick(self,e):
		self.r=255
		self.g=255
		self.b=128
		self.showrgb()
		
	def bnYellowmouseDoubleClick(self,e):
		self.r=255
		self.g=255
		self.b=0
		self.showrgb()


	def bnLightOrangemouseDoubleClick(self,e):
		self.r=255
		self.g=182
		self.b=108
		self.showrgb()
		
	def bnOrangemouseDoubleClick(self,e):
		self.r=255
		self.g=128
		self.b=0		
		self.showrgb()
		

	def bnLightGreenmouseDoubleClick(self,e):
		self.r=128
		self.g=255
		self.b=0
		self.showrgb()
		
	def bnGreenmouseDoubleClick(self,e):
		self.r=0
		self.g=255
		self.b=0				
		self.showrgb()
		
		

	def bnLightBluemouseDoubleClick(self,e):
		self.r=70
		self.g=70
		self.b=255
		self.showrgb()
		
	def bnBluemouseDoubleClick(self,e):
		self.r=0
		self.g=0
		self.b=255				
		self.showrgb()
		
				
	def bnLightRedmouseDoubleClick(self,e):
		self.r=255
		self.g=90
		self.b=90
		self.showrgb()
		
	def bnRedmouseDoubleClick(self,e):
		self.r=255
		self.g=0
		self.b=0				
		self.showrgb()
		
		
		
	def bnLightViolettmouseDoubleClick(self,e):
		self.r=255
		self.g=128
		self.b=191
		self.showrgb()
		
	def bnViolettmouseDoubleClick(self,e):
		self.r=255
		self.g=0
		self.b=128			
		self.showrgb()
		

	def bnLightBrownmouseDoubleClick(self,e):
		self.r=217
		self.g=108
		self.b=0
		self.showrgb()
		
	def bnBrownmouseDoubleClick(self,e):
		self.r=128
		self.g=64
		self.b=0			
		self.showrgb()
						
						

	def bnLightGraymouseDoubleClick(self,e):
		self.r=200
		self.g=200
		self.b=200
		self.showrgb()
		
	def bnGraymouseDoubleClick(self,e):
		self.r=129
		self.g=129
		self.b=129		
		self.showrgb()

	def showrgb(self):
		self.tRed.setText( str(self.r) )
		self.tGreen.setText( str(self.g) )
		self.tBlue.setText( str(self.b) )
		self.sliderRed.setValue(self.r)
		self.sliderGreen.setValue(self.g)
		self.sliderBlue.setValue(self.b)
		

	def mousePressEvent(self,e):
		self.tRed.setText("xxxx")
		
	def sliderRedStateChanged(self,  value):
		self.tRed.setText(str(value))
		self.r=value
		self.setColor()
		
	def sliderGreenStateChanged(self,  value):
		self.tGreen.setText(str(value))
		self.g=value
		self.setColor()
		
	def sliderBlueStateChanged(self,  value):
		self.tBlue.setText(str(value))
		self.b=value
		self.setColor()
		
	def setColor(self):
		palette = QtGui.QPalette()
		brush = QtGui.QBrush(QtGui.QColor(self.r, self.g, self.b))
		brush.setStyle(QtCore.Qt.SolidPattern)		
		palette.setBrush(QtGui.QPalette.Active, QtGui.QPalette.Base, brush)		
		self.rgb.setPalette(palette)
		self.rgb.setAutoFillBackground(True)		
		
		
		